"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HttpRule = exports.Http = exports.CustomHttpPattern = void 0;

var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));

var _helpers = require("@osmonauts/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function createBaseHttp() {
  return {
    rules: [],
    fully_decode_reserved_expansion: false
  };
}

var Http = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    var _iterator = _createForOfIteratorHelper(message.rules),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var v = _step.value;
        HttpRule.encode(v, writer.uint32(10).fork()).ldelim();
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }

    if (message.fully_decode_reserved_expansion === true) {
      writer.uint32(16).bool(message.fully_decode_reserved_expansion);
    }

    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseHttp();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.rules.push(HttpRule.decode(reader, reader.uint32()));
          break;

        case 2:
          message.fully_decode_reserved_expansion = reader.bool();
          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      rules: Array.isArray(object === null || object === void 0 ? void 0 : object.rules) ? object.rules.map(function (e) {
        return HttpRule.fromJSON(e);
      }) : [],
      fully_decode_reserved_expansion: (0, _helpers.isSet)(object.fully_decode_reserved_expansion) ? Boolean(object.fully_decode_reserved_expansion) : false
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};

    if (message.rules) {
      obj.rules = message.rules.map(function (e) {
        return e ? HttpRule.toJSON(e) : undefined;
      });
    } else {
      obj.rules = [];
    }

    message.fully_decode_reserved_expansion !== undefined && (obj.fully_decode_reserved_expansion = message.fully_decode_reserved_expansion);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$rules, _object$fully_decode_;

    var message = createBaseHttp();
    message.rules = ((_object$rules = object.rules) === null || _object$rules === void 0 ? void 0 : _object$rules.map(function (e) {
      return HttpRule.fromPartial(e);
    })) || [];
    message.fully_decode_reserved_expansion = (_object$fully_decode_ = object.fully_decode_reserved_expansion) !== null && _object$fully_decode_ !== void 0 ? _object$fully_decode_ : false;
    return message;
  }
};
exports.Http = Http;

function createBaseHttpRule() {
  return {
    selector: "",
    get: undefined,
    put: undefined,
    post: undefined,
    "delete": undefined,
    patch: undefined,
    custom: undefined,
    body: "",
    response_body: "",
    additional_bindings: []
  };
}

var HttpRule = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    if (message.selector !== "") {
      writer.uint32(10).string(message.selector);
    }

    if (message.get !== undefined) {
      writer.uint32(18).string(message.get);
    }

    if (message.put !== undefined) {
      writer.uint32(26).string(message.put);
    }

    if (message.post !== undefined) {
      writer.uint32(34).string(message.post);
    }

    if (message["delete"] !== undefined) {
      writer.uint32(42).string(message["delete"]);
    }

    if (message.patch !== undefined) {
      writer.uint32(50).string(message.patch);
    }

    if (message.custom !== undefined) {
      CustomHttpPattern.encode(message.custom, writer.uint32(66).fork()).ldelim();
    }

    if (message.body !== "") {
      writer.uint32(58).string(message.body);
    }

    if (message.response_body !== "") {
      writer.uint32(98).string(message.response_body);
    }

    var _iterator2 = _createForOfIteratorHelper(message.additional_bindings),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var v = _step2.value;
        HttpRule.encode(v, writer.uint32(90).fork()).ldelim();
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseHttpRule();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.selector = reader.string();
          break;

        case 2:
          message.get = reader.string();
          break;

        case 3:
          message.put = reader.string();
          break;

        case 4:
          message.post = reader.string();
          break;

        case 5:
          message["delete"] = reader.string();
          break;

        case 6:
          message.patch = reader.string();
          break;

        case 8:
          message.custom = CustomHttpPattern.decode(reader, reader.uint32());
          break;

        case 7:
          message.body = reader.string();
          break;

        case 12:
          message.response_body = reader.string();
          break;

        case 11:
          message.additional_bindings.push(HttpRule.decode(reader, reader.uint32()));
          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      selector: (0, _helpers.isSet)(object.selector) ? String(object.selector) : "",
      get: (0, _helpers.isSet)(object.get) ? String(object.get) : undefined,
      put: (0, _helpers.isSet)(object.put) ? String(object.put) : undefined,
      post: (0, _helpers.isSet)(object.post) ? String(object.post) : undefined,
      "delete": (0, _helpers.isSet)(object["delete"]) ? String(object["delete"]) : undefined,
      patch: (0, _helpers.isSet)(object.patch) ? String(object.patch) : undefined,
      custom: (0, _helpers.isSet)(object.custom) ? CustomHttpPattern.fromJSON(object.custom) : undefined,
      body: (0, _helpers.isSet)(object.body) ? String(object.body) : "",
      response_body: (0, _helpers.isSet)(object.response_body) ? String(object.response_body) : "",
      additional_bindings: Array.isArray(object === null || object === void 0 ? void 0 : object.additional_bindings) ? object.additional_bindings.map(function (e) {
        return HttpRule.fromJSON(e);
      }) : []
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.selector !== undefined && (obj.selector = message.selector);
    message.get !== undefined && (obj.get = message.get);
    message.put !== undefined && (obj.put = message.put);
    message.post !== undefined && (obj.post = message.post);
    message["delete"] !== undefined && (obj["delete"] = message["delete"]);
    message.patch !== undefined && (obj.patch = message.patch);
    message.custom !== undefined && (obj.custom = message.custom ? CustomHttpPattern.toJSON(message.custom) : undefined);
    message.body !== undefined && (obj.body = message.body);
    message.response_body !== undefined && (obj.response_body = message.response_body);

    if (message.additional_bindings) {
      obj.additional_bindings = message.additional_bindings.map(function (e) {
        return e ? HttpRule.toJSON(e) : undefined;
      });
    } else {
      obj.additional_bindings = [];
    }

    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$selector, _object$get, _object$put, _object$post, _object$delete, _object$patch, _object$body, _object$response_body, _object$additional_bi;

    var message = createBaseHttpRule();
    message.selector = (_object$selector = object.selector) !== null && _object$selector !== void 0 ? _object$selector : "";
    message.get = (_object$get = object.get) !== null && _object$get !== void 0 ? _object$get : undefined;
    message.put = (_object$put = object.put) !== null && _object$put !== void 0 ? _object$put : undefined;
    message.post = (_object$post = object.post) !== null && _object$post !== void 0 ? _object$post : undefined;
    message["delete"] = (_object$delete = object["delete"]) !== null && _object$delete !== void 0 ? _object$delete : undefined;
    message.patch = (_object$patch = object.patch) !== null && _object$patch !== void 0 ? _object$patch : undefined;
    message.custom = object.custom !== undefined && object.custom !== null ? CustomHttpPattern.fromPartial(object.custom) : undefined;
    message.body = (_object$body = object.body) !== null && _object$body !== void 0 ? _object$body : "";
    message.response_body = (_object$response_body = object.response_body) !== null && _object$response_body !== void 0 ? _object$response_body : "";
    message.additional_bindings = ((_object$additional_bi = object.additional_bindings) === null || _object$additional_bi === void 0 ? void 0 : _object$additional_bi.map(function (e) {
      return HttpRule.fromPartial(e);
    })) || [];
    return message;
  }
};
exports.HttpRule = HttpRule;

function createBaseCustomHttpPattern() {
  return {
    kind: "",
    path: ""
  };
}

var CustomHttpPattern = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    if (message.kind !== "") {
      writer.uint32(10).string(message.kind);
    }

    if (message.path !== "") {
      writer.uint32(18).string(message.path);
    }

    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseCustomHttpPattern();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.kind = reader.string();
          break;

        case 2:
          message.path = reader.string();
          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      kind: (0, _helpers.isSet)(object.kind) ? String(object.kind) : "",
      path: (0, _helpers.isSet)(object.path) ? String(object.path) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.kind !== undefined && (obj.kind = message.kind);
    message.path !== undefined && (obj.path = message.path);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$kind, _object$path;

    var message = createBaseCustomHttpPattern();
    message.kind = (_object$kind = object.kind) !== null && _object$kind !== void 0 ? _object$kind : "";
    message.path = (_object$path = object.path) !== null && _object$path !== void 0 ? _object$path : "";
    return message;
  }
};
exports.CustomHttpPattern = CustomHttpPattern;