"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryAppVersionResponse = exports.QueryAppVersionRequest = void 0;

var _channel = require("../../channel/v1/channel");

var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));

var _helpers = require("@osmonauts/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function createBaseQueryAppVersionRequest() {
  return {
    port_id: "",
    connection_id: "",
    ordering: 0,
    counterparty: undefined,
    proposed_version: ""
  };
}

var QueryAppVersionRequest = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    if (message.port_id !== "") {
      writer.uint32(10).string(message.port_id);
    }

    if (message.connection_id !== "") {
      writer.uint32(18).string(message.connection_id);
    }

    if (message.ordering !== 0) {
      writer.uint32(24).int32(message.ordering);
    }

    if (message.counterparty !== undefined) {
      _channel.Counterparty.encode(message.counterparty, writer.uint32(34).fork()).ldelim();
    }

    if (message.proposed_version !== "") {
      writer.uint32(42).string(message.proposed_version);
    }

    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseQueryAppVersionRequest();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.port_id = reader.string();
          break;

        case 2:
          message.connection_id = reader.string();
          break;

        case 3:
          message.ordering = reader.int32();
          break;

        case 4:
          message.counterparty = _channel.Counterparty.decode(reader, reader.uint32());
          break;

        case 5:
          message.proposed_version = reader.string();
          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      port_id: (0, _helpers.isSet)(object.port_id) ? String(object.port_id) : "",
      connection_id: (0, _helpers.isSet)(object.connection_id) ? String(object.connection_id) : "",
      ordering: (0, _helpers.isSet)(object.ordering) ? (0, _channel.orderFromJSON)(object.ordering) : 0,
      counterparty: (0, _helpers.isSet)(object.counterparty) ? _channel.Counterparty.fromJSON(object.counterparty) : undefined,
      proposed_version: (0, _helpers.isSet)(object.proposed_version) ? String(object.proposed_version) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.port_id !== undefined && (obj.port_id = message.port_id);
    message.connection_id !== undefined && (obj.connection_id = message.connection_id);
    message.ordering !== undefined && (obj.ordering = (0, _channel.orderToJSON)(message.ordering));
    message.counterparty !== undefined && (obj.counterparty = message.counterparty ? _channel.Counterparty.toJSON(message.counterparty) : undefined);
    message.proposed_version !== undefined && (obj.proposed_version = message.proposed_version);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$port_id, _object$connection_id, _object$ordering, _object$proposed_vers;

    var message = createBaseQueryAppVersionRequest();
    message.port_id = (_object$port_id = object.port_id) !== null && _object$port_id !== void 0 ? _object$port_id : "";
    message.connection_id = (_object$connection_id = object.connection_id) !== null && _object$connection_id !== void 0 ? _object$connection_id : "";
    message.ordering = (_object$ordering = object.ordering) !== null && _object$ordering !== void 0 ? _object$ordering : 0;
    message.counterparty = object.counterparty !== undefined && object.counterparty !== null ? _channel.Counterparty.fromPartial(object.counterparty) : undefined;
    message.proposed_version = (_object$proposed_vers = object.proposed_version) !== null && _object$proposed_vers !== void 0 ? _object$proposed_vers : "";
    return message;
  }
};
exports.QueryAppVersionRequest = QueryAppVersionRequest;

function createBaseQueryAppVersionResponse() {
  return {
    port_id: "",
    version: ""
  };
}

var QueryAppVersionResponse = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    if (message.port_id !== "") {
      writer.uint32(10).string(message.port_id);
    }

    if (message.version !== "") {
      writer.uint32(18).string(message.version);
    }

    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseQueryAppVersionResponse();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.port_id = reader.string();
          break;

        case 2:
          message.version = reader.string();
          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      port_id: (0, _helpers.isSet)(object.port_id) ? String(object.port_id) : "",
      version: (0, _helpers.isSet)(object.version) ? String(object.version) : ""
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.port_id !== undefined && (obj.port_id = message.port_id);
    message.version !== undefined && (obj.version = message.version);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var _object$port_id2, _object$version;

    var message = createBaseQueryAppVersionResponse();
    message.port_id = (_object$port_id2 = object.port_id) !== null && _object$port_id2 !== void 0 ? _object$port_id2 : "";
    message.version = (_object$version = object.version) !== null && _object$version !== void 0 ? _object$version : "";
    return message;
  }
};
exports.QueryAppVersionResponse = QueryAppVersionResponse;