"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GenesisState = void 0;

var _genesis = require("../../client/v1/genesis");

var _genesis2 = require("../../connection/v1/genesis");

var _genesis3 = require("../../channel/v1/genesis");

var _m0 = _interopRequireWildcard(require("protobufjs/minimal"));

var _helpers = require("@osmonauts/helpers");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function createBaseGenesisState() {
  return {
    client_genesis: undefined,
    connection_genesis: undefined,
    channel_genesis: undefined
  };
}

var GenesisState = {
  encode: function encode(message) {
    var writer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _m0.Writer.create();

    if (message.client_genesis !== undefined) {
      _genesis.GenesisState.encode(message.client_genesis, writer.uint32(10).fork()).ldelim();
    }

    if (message.connection_genesis !== undefined) {
      _genesis2.GenesisState.encode(message.connection_genesis, writer.uint32(18).fork()).ldelim();
    }

    if (message.channel_genesis !== undefined) {
      _genesis3.GenesisState.encode(message.channel_genesis, writer.uint32(26).fork()).ldelim();
    }

    return writer;
  },
  decode: function decode(input, length) {
    var reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    var end = length === undefined ? reader.len : reader.pos + length;
    var message = createBaseGenesisState();

    while (reader.pos < end) {
      var tag = reader.uint32();

      switch (tag >>> 3) {
        case 1:
          message.client_genesis = _genesis.GenesisState.decode(reader, reader.uint32());
          break;

        case 2:
          message.connection_genesis = _genesis2.GenesisState.decode(reader, reader.uint32());
          break;

        case 3:
          message.channel_genesis = _genesis3.GenesisState.decode(reader, reader.uint32());
          break;

        default:
          reader.skipType(tag & 7);
          break;
      }
    }

    return message;
  },
  fromJSON: function fromJSON(object) {
    return {
      client_genesis: (0, _helpers.isSet)(object.client_genesis) ? _genesis.GenesisState.fromJSON(object.client_genesis) : undefined,
      connection_genesis: (0, _helpers.isSet)(object.connection_genesis) ? _genesis2.GenesisState.fromJSON(object.connection_genesis) : undefined,
      channel_genesis: (0, _helpers.isSet)(object.channel_genesis) ? _genesis3.GenesisState.fromJSON(object.channel_genesis) : undefined
    };
  },
  toJSON: function toJSON(message) {
    var obj = {};
    message.client_genesis !== undefined && (obj.client_genesis = message.client_genesis ? _genesis.GenesisState.toJSON(message.client_genesis) : undefined);
    message.connection_genesis !== undefined && (obj.connection_genesis = message.connection_genesis ? _genesis2.GenesisState.toJSON(message.connection_genesis) : undefined);
    message.channel_genesis !== undefined && (obj.channel_genesis = message.channel_genesis ? _genesis3.GenesisState.toJSON(message.channel_genesis) : undefined);
    return obj;
  },
  fromPartial: function fromPartial(object) {
    var message = createBaseGenesisState();
    message.client_genesis = object.client_genesis !== undefined && object.client_genesis !== null ? GenesisState.fromPartial(object.client_genesis) : undefined;
    message.connection_genesis = object.connection_genesis !== undefined && object.connection_genesis !== null ? GenesisState.fromPartial(object.connection_genesis) : undefined;
    message.channel_genesis = object.channel_genesis !== undefined && object.channel_genesis !== null ? GenesisState.fromPartial(object.channel_genesis) : undefined;
    return message;
  }
};
exports.GenesisState = GenesisState;